#ifndef MODELWINDOW_H
#define MODELWINDOW_H

#include <QOpenGLContext>
#include <QOpenGLTexture>
#include <QKeyEvent>
#include <QCoreApplication>

#include <QWindow>
#include <QOpenGLFunctions>
#include <QMatrix4x4>
#include <QOpenGLShaderProgram>
#include <QScreen>
#include <QtMath>
#include <QOpenGLPaintDevice>
#include <QImage>

/**
QT_BEGIN_NAMESPACE
class QPainter;
class QOpenGLContext;
class QOpenGLPaintDevice;
QT_END_NAMESPACE
**/


class ModelWindow : public QWindow, protected QOpenGLFunctions
{
	Q_OBJECT
public:
	ModelWindow( QWindow *parent = nullptr );
    // ~ModelWindow();

	// explicit ModelWindow( QWindow *parent = nullptr );
	void initialize();
	void render( );
	void inicializa_matrices(void);

public slots:
    void renderNow();

protected:
	bool event(QEvent *event);
	void exposeEvent(QExposeEvent *event);
	void keyPressEvent( QKeyEvent * e );

private:
	GLint m_posAttr = 0;
	GLint m_matrixUniform = 0;
	GLint m_texCoord = 0;

	QOpenGLShaderProgram *m_program = nullptr;
	int m_frame = 0;

	float MK[16]; 
	float MRT[16];
	float f = 1279.1435;
	QMatrix4x4 K, RT;

    QOpenGLContext *m_context = nullptr;
	// QOpenGLPaintDevice *m_device = nullptr;

	QImage img_fondo;
	QOpenGLTexture *texture;
};

#endif
